/*
 * Copyright (c) 2008-2009, Maconnect
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code MUST retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Maconnect nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import "FVMusicBrainz.h"
#import "FVPUID.h"
#import "FVWavExporter.h"

@implementation FVMusicBrainz

-(NSArray*)trackInfoForWavFileAtPath:(NSString*)path duration:(float)duration clientID:(NSString*)cid version:(NSString*)v
{
	if (!path)
		return nil;
	
	NSArray			*puids=[FVPUID listOfPUIDsForWavFileAtPath:path duration:duration clientID:cid version:v];
	if (!puids || ![puids count])
		return nil;
	
	return [FVMBTrackInfo trackInfoForPUID:[puids objectAtIndex:0]];
}

-(NSArray*)trackInfoForMovieAtPath:(NSString*)path clientID:(NSString*)cid version:(NSString*)v
{
	FVWavExporter		*f=[[[FVWavExporter alloc] init] autorelease];
	NSString			*tempFileName=[NSString stringWithFormat:@"%@-tempfile-%u.wav",
									   @"FOO",
									   (NSUInteger)self
	];
	NSString			*tempFolder=NSTemporaryDirectory();
	float				duration=0.;
	tempFolder=tempFolder ? tempFolder : @"/tmp";
	tempFileName=[tempFolder stringByAppendingPathComponent:tempFileName];
	
	if ([f exportPath:path toPath:tempFileName duration:&duration])
	{
		NSArray			*a=[self trackInfoForWavFileAtPath:tempFileName duration:duration clientID:cid version:v];
		[[NSFileManager defaultManager] removeFileAtPath:tempFileName handler:NULL];
		return a;
	}
	
	return nil;
}

@end
