/*
 * Copyright (c) 2008-2009, Maconnect
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code MUST retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Maconnect nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#import <Cocoa/Cocoa.h>
#import "FVMusicBrainz.h"

void printUsage()
{
	printf("Usage: GetMusicBrainzTrackInfo quicktimeMovieFilePath clientID clientVersion [duration]\n");
}

int main(int argc, char *argv[])
{
	if (argc < 2){
		printUsage();
		return EXIT_FAILURE;
	}
	
	NSAutoreleasePool	*p=[[NSAutoreleasePool alloc] init];
	
	NSString		*src=[[NSFileManager defaultManager] stringWithFileSystemRepresentation:argv[1] length:strlen(argv[1])];
	NSString		*cid=[[NSFileManager defaultManager] stringWithFileSystemRepresentation:argv[2] length:strlen(argv[2])];
	NSString		*ver=[[NSFileManager defaultManager] stringWithFileSystemRepresentation:argv[3] length:strlen(argv[3])];
	float			duration= argc > 4 ? atof(argv[4]) : 0.;
	
	FVMusicBrainz	*f=[[FVMusicBrainz alloc] init];
	NSArray			*a=NULL;
	
	if ([[src pathExtension] caseInsensitiveCompare:@"wav"]==NSOrderedSame)
		a=[f trackInfoForWavFileAtPath:src duration:duration clientID:cid version:ver];
	else
		a=[f trackInfoForMovieAtPath:src clientID:cid version:ver];
	
	a= a ? a : [NSArray array];
	
	NSData			*data=[NSKeyedArchiver archivedDataWithRootObject:a];
	fwrite([data bytes], [data length], 1, stdout);
	
	[p release];
	return EXIT_SUCCESS;
}
